package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class MazeState extends FlxState
	{
		[Embed(source = "data/roomtestbig.png")] public static var ImgRoom:Class;
		
		public const tileSize:int=32;
				
		public static var score:int;
		
		public var fadedin:Boolean;
		
		public static var oldx:Number;
		public static var oldy:Number;	
		
		public var player:FlxSprite;
		
		private var roomType:int;
		
		override public function create():void
		{			
			if (score==8)
			{
				FlxG.state = new EndState();
				FlxG.playMusic(GameState.SndTitle);
				return;
			}
			add(player);
			var bg:FlxSprite = new FlxSprite(0,0,ImgRoom);
			add(bg);
			
			roomType=Math.random()*4;
			trace("ROOMTYPE",roomType);
			
			GameState.strategy=roomType;
			var area:Array = GameState.generateLevel();

			var pedastal:FlxSprite = new FlxSprite(248,248);
			pedastal.createGraphic(24,24,0x00000000,true);
			
			var data:BitmapData = pedastal.pixels;
			for (var i:int=0;i<6;i++)
			{
				for (var j:int=0;j<6;j++)
				{
					if (area[0][i][j]==1)
						data.fillRect(new Rectangle(i*4,j*4,4,4),0xff281915);
				}
			}
			pedastal.pixels=data;
			
			add(pedastal);
	

			// add pedastal
			
			player = new FlxSprite(oldx,oldy);
			player.loadGraphic(Player.Image,false,false,12,12);
			player.scale.x=3;
			player.scale.y=3;
			player.maxVelocity.x=120;
			player.maxVelocity.y=120;
			player.drag = new FlxPoint(400,400);
			
			// add floor flowers
			
			var tscore:int=score+1;
			for (i=0;i<3;i++)
			{
				for (j=0;j<3;j++)
				{
					if (i==1&&j==1)
						continue;
					tscore--;
					if (tscore<=0)
						continue;
					var f:FlxSprite = new FlxSprite(169+53*3.0/2*i,168+53*3.0/2*j,RPGState.ImgMazeFlower);
					add(f);
				}
			}
			
			add(player);
			
			fadedin=false;
			FlxG.flash.start(0xff000000,1,FlashFinished);
		}
		
		public function FlashFinished():void
		{
			fadedin=true;
		}
		
		public var _time:Number;
		
		override public function update():void
		{		
			if (!fadedin)
			{
				super.update();
				return;
			}
			
			_time+=FlxG.elapsed;
			
			if (FlxG.keys.LEFT || FlxG.keys.A)
			{
				player.velocity.x-=10;
			}
			if (FlxG.keys.RIGHT || FlxG.keys.D)
			{
				player.velocity.x+=10;
			}
			if (FlxG.keys.UP || FlxG.keys.W)
			{
				//this.facing=FlxSprite.LEFT;
				player.velocity.y-=10;
			}
			if (FlxG.keys.DOWN || FlxG.keys.S)
			{
				//this.facing=FlxSprite.RIGHT;
				player.velocity.y+=10;
			}
			
			super.update();
			
			if (player.x<36 && !(player.y>200 && player.y<296))
				player.x=36;
			if (player.x>475-12 && !(player.y>200 && player.y<296))
				player.x=475-12;
			if (player.y<36&& !(player.x>200 && player.x<296))
				player.y=36;
			if (player.y>475-18 && !(player.x>200 && player.x<296))
				player.y=475-18;
			
			if (player.x<-3*12)
			{
				if (roomType==2)
				{
					score++;
				}
				else
				{
					score--;
					if (score<0) 
						score=0;
				}
				
				oldx=FlxG.width-3*12;
				oldy=player.y;
				fadedin=false;
				FlxG.fade.start(0xff0000000,1,NewRoom);			
			}
			else if (player.x>FlxG.width)
			{
				if (roomType==3)
				{
					score++;
				}
				else
				{
					score--;
					if (score<0) 
						score=0;
				}
				{
					oldx=6;
					oldy=player.y;
					fadedin=false;
					FlxG.fade.start(0xff0000000,1,NewRoom);
				}
			}
			
			
			if (player.y<-3*12)
			{
				if (roomType==0)
				{
					score++;
				}
				else
				{
					score--;
					if (score<0) 
						score=0;
				}
				{
					oldy=FlxG.height-3*12;
					oldx=player.x;
					fadedin=false;
					FlxG.fade.start(0xff0000000,1,NewRoom);
				}
			}
			else if (player.y>FlxG.height)
			{
				if (roomType==1)
				{
					score++;
				}
				else
				{
					score--;
					if (score<0) 
						score=0;
				}
				{
					oldy=6;
					oldx=player.x;
					fadedin=false;
					FlxG.fade.start(0xff0000000,1,NewRoom);
				}
			}
		
		}	
		
		public function NewRoom():void
		{		
			FlxG.state=new MazeState();
		}
		
	}
	
}