package
{
	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	
	public class Player extends FlxSprite
	{
		[Embed(source = "data/player.png")] public static var Image:Class;
		
		public var cx:Number;
		public var cy:Number;
		
		public var target:int;
		// 0 - center
		// 1 - up
		// 2 - down
		// 3 - left
		// 4 - right
		
		public function Player(X:Number, Y:Number)
		{
			super(X, Y, null);
			this.loadGraphic(Image,true,true,12,12);
			cx = FlxG.width/2+this.width/2;
			cy = FlxG.height/2+this.height/2;
			this.addAnimation("up",[0],2);
			this.addAnimation("down",[3],2);
			this.addAnimation("left",[2],2);
			this.addAnimation("right",[1],2);
			
			
			
			//this.addAnimation("jump",[1],2);
			this.solid=true;
			this.maxVelocity.x=80;
			this.maxVelocity.y=80;
			this.drag = new FlxPoint(400,400);
			stick=false;
		//	this.acceleration.y=300;
		}
		public var stick:Boolean;
		
		override public function update():void
		{
			if (stick)
			{
				super.update();
				return;
			}
			
			var toPlay:String;
			this.facing=FlxSprite.RIGHT;
						
			if (FlxG.keys.LEFT || FlxG.keys.A)
			{
				velocity.x-=10;
			}
			if (FlxG.keys.RIGHT || FlxG.keys.D)
			{
				velocity.x+=10;
			}
			if (FlxG.keys.UP || FlxG.keys.W)
			{
				//this.facing=FlxSprite.LEFT;
				velocity.y-=10;
			}
			if (FlxG.keys.DOWN || FlxG.keys.S)
			{
				//this.facing=FlxSprite.RIGHT;
				velocity.y+=10;
			}
		
			var dx:Number = this.x+this.width/2-cx;
			var dy:Number = this.y+this.height/2-cy;
			var d:Number = Math.sqrt(dx*dx+dy*dy);
			var s:Number = 2+(160.0-d)*0.5/160.0;
			
			if (dx>140-this.width/2)
			{
				x=cx+140-this.width/2-this.width/2;
			}
			else if (dx<-140)
			{
				x=cx-140-this.width/2;
			}
			if (dy>140-this.height/2)
			{
				y=cy+140-this.height/2-this.height/2;
			}
			else if (dy<-140)
			{
				y=cy-140-this.height/2;
			}
			
			if (Math.abs(dx)<50 && Math.abs(dy)<50)
			{
				this.play("up");			
			}
			else if (dx<0 && Math.abs(dy)<Math.abs(dx))
			{
				this.play("left");
				if (dy>60-this.width*3.0/2)
					y=cy+60-2*this.width;
				else if (dy<-60+this.width/2)
					y=cy-60;
			}
			else if (dy<0 && Math.abs(dx)<Math.abs(dy))
			{
				this.play("up");
				if (dx>60-this.width*3.0/2)
					x=cx+60-2*this.width;
				else if (dx<-60+this.width/2)
					x=cx-60;
			}
			else if (dx>0 && Math.abs(dy)<Math.abs(dx))
			{
				this.play("right");	
				if (dy>60-this.width*3.0/2)
					y=cy+60-2*this.width;
				else if (dy<-60+this.width/2)
					y=cy-60;
			}
			else
			{
				this.play("down");
				if (dx>60-this.width*3.0/2)
					x=cx+60-2*this.width;
				else if (dx<-60+this.width/2)
					x=cx-60;
			}
			this.scale.x=s;
			this.scale.y=s;
			
			super.update();
		}
	}
	
}