package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class RPGState extends FlxState
	{
		[Embed(source = "data/mapreal.png")] public static var ImgRoom:Class;
		[Embed(source = "data/wedge.png")] public static var ImgCenterTile:Class;
		[Embed(source = "data/teleport.png")] public static var ImgTeleport:Class;
		[Embed(source = "data/full.png")] public static var ImgFull:Class;
		[Embed(source = "data/mazeflower.png")] public static var ImgMazeFlower:Class;
		[Embed(source = "data/empty.png")] public static var ImgEmpty:Class;
		[Embed(source = "data/selector.png")] public static var ImgSelector:Class;
		[Embed(source = "data/selectorFull.png")] public static var ImgSelectorOn:Class;

		public const tileSize:int=32;
		
		public var player:Player;
		
		public var teleport:FlxSprite;
		public var d1:FlxSprite;
		public var d2:FlxSprite;
		public var d3:FlxSprite;
		public var d4:FlxSprite;
		
		public var c1:FlxSprite;
		public var c2:FlxSprite;
		public var c3:FlxSprite;
		public var c4:FlxSprite;
		
		public static var finished1:Boolean;
		public static var finished2:Boolean;
		public static var finished3:Boolean;
		public static var finished4:Boolean;
		
		
		public static var fadedin:Boolean;
		
		public static var hasData:Boolean=false;
		public static var oldx:Number;
		public static var oldy:Number;		
		
		override public function create():void
		{		
			fadedin=false;
			this._time=0;
			
			d1 = new FlxSprite(246,113);
			d1.createGraphic(26,7,0xff000000);
			d1.visible=false;
			add(d1);
			d2 = new FlxSprite(246,403);
			d2.createGraphic(26,7,0xff000000);
			d2.visible=false;
			add(d2);
			d3 = new FlxSprite(113,246);
			d3.createGraphic(7,26,0xff000000);
			d3.visible=false;
			add(d3);
			d4 = new FlxSprite(403,246);
			d4.createGraphic(7,26,0xff000000);
			d4.visible=false;
			add(d4);
			
			
			var bg:FlxSprite = new FlxSprite(0,0,ImgRoom);
			add(bg);
			
			c1 = new FlxSprite(239,239);
			c1.loadGraphic(ImgCenterTile,true,false,40,40);
			c1.addAnimation("a",[0]);
			c1.play("a");
			c1.visible=RPGState.finished1;
			this.add(c1);
			c2 = new FlxSprite(239,239);
			c2.loadGraphic(ImgCenterTile,true,false,40,40);
			c2.addAnimation("a",[2]);
			c2.play("a");
			c2.visible=RPGState.finished2;
			this.add(c2);
			c3 = new FlxSprite(239,239);
			c3.loadGraphic(ImgCenterTile,true,false,40,40);
			c3.addAnimation("a",[3]);
			c3.play("a");
			c3.visible=RPGState.finished3;
			this.add(c3);
			c4 = new FlxSprite(239,239);
			c4.loadGraphic(ImgCenterTile,true,false,40,40);
			c4.addAnimation("a",[1]);
			c4.play("a");
			c4.visible=RPGState.finished4;
			this.add(c4);
			
			if (finished1&&finished2&&finished3&&finished4)
			{
				this.teleport = new FlxSprite(239,239);
				teleport.loadGraphic(ImgTeleport,true,false,40,40);
				teleport.addAnimation("play",[0,1,2,1],3);
				this.add(teleport);
				teleport.play("play");
			}
			else
			{
				teleport=null;
			}
			
			if (hasData)
			{
				player = new Player(oldx,oldy);
			}
			else
				player = new Player(FlxG.height/2,FlxG.width/2);
				
			add(player);
			FlxG.flash.start(0xff000000,1,FlashFinished);
		}
		
		public function FlashFinished():void
		{
			fadedin=true;
		}
		
		public var _time:Number;
		
		override public function update():void
		{		
			if (!fadedin)
			{
				super.update();
				return;
			}
			
			
			_time+=FlxG.elapsed;
			
			if (!RPGState.finished1 && FlxU.overlap(player,d1,dontDelete))
			{
				FlxG.fade.start(0xff000000,1,LoadD1,true);
				fadedin=false;
				player.stick=true;
			}
			else if (!RPGState.finished2 && FlxU.overlap(player,d2,dontDelete))
			{
				FlxG.fade.start(0xff000000,1,LoadD2,true);	
				fadedin=false;		
				player.stick=true;	
			}
			else if (!RPGState.finished3 && FlxU.overlap(player,d3,dontDelete))
			{				
				FlxG.fade.start(0xff000000,1,LoadD3,true);	
				fadedin=false;		
				player.stick=true;	
			}
			else if (!RPGState.finished4 && FlxU.overlap(player,d4,dontDelete))
			{				
				FlxG.fade.start(0xff000000,1,LoadD4,true);	
				fadedin=false;
				player.stick=true;
			}
			
			if (this.teleport!=null && FlxU.overlap(player,teleport,dontDelete))
			{
				FlxG.fade.start(0xff000000,1,LoadMaze,true);
				fadedin=false;
				player.stick=true;
				FlxG.music.fadeOut(1);			
			}
		
			super.update();
		}		
		
		private function dontDelete(a:FlxSprite,b:FlxSprite):Boolean{return true;}
		
		private function LoadD1():void
		{
			GameState.strategy=0;
			hasData=true;
			oldx=player.x;
			oldy=player.y;
			FlxG.state = new GameState();
		}
		private function LoadD2():void
		{
			GameState.strategy=1;
			hasData=true;
			oldx=player.x;
			oldy=player.y;
			FlxG.state = new GameState();			
		}
		private function LoadD3():void
		{
			GameState.strategy=2;
			hasData=true;
			oldx=player.x;
			oldy=player.y;
			FlxG.state = new GameState();			
		}
		private function LoadD4():void
		{
			GameState.strategy=3;
			hasData=true;
			oldx=player.x;
			oldy=player.y;
			FlxG.state = new GameState();			
		}
		
		private function LoadMaze():void
		{
			GameState.strategy=0;
			MazeState.score=0;
			MazeState.oldx=FlxG.width/2-6;
			MazeState.oldy=FlxG.height*2.0/3.0-6;
			FlxG.playMusic(GameState.SndSection2);
			FlxG.state = new MazeState();			
		}
	}
	
}